# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_activedirectoryaccessentry`](#dsc_activedirectoryaccessentry): The DSC ActiveDirectoryAccessEntry resource type. Automatically generated from version 1.4.1
* [`dsc_activedirectoryauditruleentry`](#dsc_activedirectoryauditruleentry): The DSC ActiveDirectoryAuditRuleEntry resource type. Automatically generated from version 1.4.1
* [`dsc_filesystemauditruleentry`](#dsc_filesystemauditruleentry): The DSC FileSystemAuditRuleEntry resource type. Automatically generated from version 1.4.1
* [`dsc_ntfsaccessentry`](#dsc_ntfsaccessentry): The DSC NTFSAccessEntry resource type. Automatically generated from version 1.4.1
* [`dsc_registryaccessentry`](#dsc_registryaccessentry): The DSC RegistryAccessEntry resource type. Automatically generated from version 1.4.1

## Resource types

### `dsc_activedirectoryaccessentry`

The DSC ActiveDirectoryAccessEntry resource type.
Automatically generated from version 1.4.1

#### Properties

The following properties are available in the `dsc_activedirectoryaccessentry` type.

##### `dsc_accesscontrollist`

Data type: `Array[Struct[{
              accesscontrolentry => Array[Struct[{
                cim_instance_type => 'ActiveDirectoryAccessRule',
                inheritedobjecttype => Optional[String],
                ensure => Enum['Present', 'Absent'],
                objecttype => Optional[String],
                activedirectoryrights => Array[Enum['AccessSystemSecurity', 'CreateChild', 'Delete', 'DeleteChild', 'DeleteTree', 'ExtendedRight', 'GenericAll', 'GenericExecute', 'GenericRead', 'GenericWrite', 'ListChildren', 'ListObject', 'ReadControl', 'ReadProperty', 'Self', 'WriteDacl', 'WriteOwner', 'WriteProperty']],
                accesscontroltype => Enum['Allow', 'Deny'],
                inheritancetype => Optional[Enum['All', 'Children', 'Descendents', 'None', 'SelfAndChildren']]
              }]],
              forceprincipal => Optional[Boolean],
              principal => Optional[String],
            }]]`

Indicates the access control information in the form of an array of instances of the ActiveDirectoryAccessControlList CIM class.

#### Parameters

The following parameters are available in the `dsc_activedirectoryaccessentry` type.

##### `dsc_distinguishedname`

namevar

Data type: `String`

Indicates the Distinguished Name value for the target Active Directory Object.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_activedirectoryauditruleentry`

The DSC ActiveDirectoryAuditRuleEntry resource type.
Automatically generated from version 1.4.1

#### Properties

The following properties are available in the `dsc_activedirectoryauditruleentry` type.

##### `dsc_accesscontrollist`

Data type: `Array[Struct[{
              accesscontrolentry => Array[Struct[{
                cim_instance_type => 'ActiveDirectoryAuditRule',
                inheritedobjecttype => Optional[String],
                ensure => Enum['Present', 'Absent'],
                objecttype => Optional[String],
                auditflags => Enum['Success', 'Failure'],
                activedirectoryrights => Array[Enum['AccessSystemSecurity', 'CreateChild', 'Delete', 'DeleteChild', 'DeleteTree', 'ExtendedRight', 'GenericAll', 'GenericExecute', 'GenericRead', 'GenericWrite', 'ListChildren', 'ListObject', 'ReadControl', 'ReadProperty', 'Self', 'WriteDacl', 'WriteOwner', 'WriteProperty']],
                inheritancetype => Optional[Enum['All', 'Children', 'Descendents', 'None', 'SelfAndChildren']]
              }]],
              forceprincipal => Optional[Boolean],
              principal => String,
            }]]`

Indicates the access control information in the form of an array of instances of the ActiveDirectoryAuditRuleList CIM class.

#### Parameters

The following parameters are available in the `dsc_activedirectoryauditruleentry` type.

##### `dsc_distinguishedname`

namevar

Data type: `String`

Indicates the Distinguished Name value for the target Active Directory Object.

##### `dsc_force`

Data type: `Optional[Boolean]`

Indicates whether the rights defined should be enforced. Will remove any rights not explicitly defined in the
configuration for the path.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_filesystemauditruleentry`

The DSC FileSystemAuditRuleEntry resource type.
Automatically generated from version 1.4.1

#### Properties

The following properties are available in the `dsc_filesystemauditruleentry` type.

##### `dsc_auditrulelist`

Data type: `Array[Struct[{
              auditruleentry => Array[Struct[{
                auditflags => Enum['None', 'Success', 'Failure'],
                inheritance => Enum['This folder only', 'This folder subfolders and files', 'This folder and subfolders', 'This folder and files', 'Subfolders and files only', 'Subfolders only', 'Files only'],
                ensure => Enum['Present', 'Absent'],
                cim_instance_type => 'FileSystemAuditRule',
                filesystemrights => Array[Enum['AppendData', 'ChangePermissions', 'CreateDirectories', 'CreateFiles', 'Delete', 'DeleteSubdirectoriesAndFiles', 'ExecuteFile', 'FullControl', 'ListDirectory', 'Modify', 'Read', 'ReadAndExecute', 'ReadAttributes', 'ReadData', 'ReadExtendedAttributes', 'ReadPermissions', 'Synchronize', 'TakeOwnership', 'Traverse', 'Write', 'WriteAttributes', 'WriteData', 'WriteExtendedAttributes']]
              }]],
              principal => String,
              forceprincipal => Boolean,
            }]]`

Indicates the audit rule information in the form of an array of instances of the FileSystemAuditRuleList CIM class.

#### Parameters

The following parameters are available in the `dsc_filesystemauditruleentry` type.

##### `dsc_force`

Data type: `Optional[Boolean]`

Indicates whether the audit rules defined should be enforced. Will remove any audit rules not explicitly defined in the
configuration for the path.

##### `dsc_path`

namevar

Data type: `String`

Indicates the path to the target item.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_ntfsaccessentry`

The DSC NTFSAccessEntry resource type.
Automatically generated from version 1.4.1

#### Properties

The following properties are available in the `dsc_ntfsaccessentry` type.

##### `dsc_accesscontrollist`

Data type: `Array[Struct[{
              accesscontrolentry => Array[Struct[{
                accesscontroltype => Enum['Allow', 'Deny'],
                inheritance => Enum['This folder only', 'This folder subfolders and files', 'This folder and subfolders', 'This folder and files', 'Subfolders and files only', 'Subfolders only', 'Files only'],
                ensure => Enum['Present', 'Absent'],
                cim_instance_type => 'NTFSAccessControlEntry',
                filesystemrights => Array[Enum['AppendData', 'ChangePermissions', 'CreateDirectories', 'CreateFiles', 'Delete', 'DeleteSubdirectoriesAndFiles', 'ExecuteFile', 'FullControl', 'ListDirectory', 'Modify', 'Read', 'ReadAndExecute', 'ReadAttributes', 'ReadData', 'ReadExtendedAttributes', 'ReadPermissions', 'Synchronize', 'TakeOwnership', 'Traverse', 'Write', 'WriteAttributes', 'WriteData', 'WriteExtendedAttributes']]
              }]],
              forceprincipal => Optional[Boolean],
              principal => Optional[String],
            }]]`

Indicates the access control information in the form of an array of instances of the NTFSAccessControlList CIM class.

#### Parameters

The following parameters are available in the `dsc_ntfsaccessentry` type.

##### `dsc_force`

Data type: `Optional[Boolean]`

 

##### `dsc_path`

namevar

Data type: `String`

Indicates the path to the target item.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_registryaccessentry`

The DSC RegistryAccessEntry resource type.
Automatically generated from version 1.4.1

#### Properties

The following properties are available in the `dsc_registryaccessentry` type.

##### `dsc_accesscontrollist`

Data type: `Array[Struct[{
              accesscontrolentry => Array[Struct[{
                accesscontroltype => Optional[Enum['Allow', 'Deny']],
                rights => Optional[Array[Enum['ChangePermissions', 'CreateLink', 'CreateSubKey', 'Delete', 'EnumerateSubKeys', 'ExecuteKey', 'FullControl', 'Notify', 'QueryValues', 'ReadKey', 'ReadPermissions', 'SetValue', 'TakeOwnership', 'WriteKey']]],
                inheritance => Optional[Enum['This Key Only', 'This Key and Subkeys', 'SubKeys Only']],
                ensure => Optional[Enum['Present', 'Absent']],
                cim_instance_type => 'AccessControlEntry'
              }]],
              forceprincipal => Optional[Boolean],
              principal => Optional[String],
            }]]`

Indicates the access control information in the form of an array of instances of the RegistryRule CIM class.

#### Parameters

The following parameters are available in the `dsc_registryaccessentry` type.

##### `dsc_force`

Data type: `Optional[Boolean]`

 

##### `dsc_path`

namevar

Data type: `String`

Indicates the path to the target item.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

